﻿using Syncfusion.UI.Xaml.Schedule;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace MappingAppointment
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    /// 

  
    public sealed partial class MainPage : Page
    {
        private bool isLoaded;
        private bool isLoaded1;
        DispatcherTimer timer = new DispatcherTimer();
        private ScheduleDaysView scheduleDayView;
        private ScheduleVerticalTimeSlotItemsControl timeSlotControl;
        private ScrollViewer daysScrollViewer;
        private ScheduleDaysView scheduleDateView1;
        private ScheduleVerticalTimeSlotItemsControl timeSlotControl1;
        private ScrollViewer daysScrollViewer1;
        public MainPage()
        {
            this.InitializeComponent();
            schedule.Loaded += Schedule_Loaded;
            schedule1.Loaded += Schedule1_Loaded;
            schedule.VisibleDatesChanging += Schedule_VisibleDatesChanging;
            schedule1.VisibleDatesChanging += Schedule1_VisibleDatesChanging;
        
        }

        private void Schedule1_VisibleDatesChanging(object sender, VisibleDatesChangingEventArgs e)
        {
            isLoaded1 = true;
            Timer();
        }

        private void Schedule_VisibleDatesChanging(object sender, VisibleDatesChangingEventArgs e)
        {
            isLoaded = true;
            Timer();
        }

        private void Schedule1_Loaded(object sender, RoutedEventArgs e)
        {
            isLoaded1 = true;
            Timer();
        }

        private void Schedule_Loaded(object sender, RoutedEventArgs e)
        {
            isLoaded = true;
            Timer();
        }
        void Timer()
        {
            timer.Interval = new TimeSpan(0, 0, 0,0 ,500);
            timer.Start();
            timer.Tick += Timer_Tick;
        }
    

        private void Timer_Tick(object sender, object e)
        {
            FindScheduleElements();
            FindScheduleElements1();
            timer.Stop();
        }

        private void FindScheduleElements()
        {
            if (isLoaded)
            {
                scheduleDayView = GetScheduleDateView(schedule.VisibleDates[0]);
                isLoaded = false;
            }

            timeSlotControl = scheduleDayView.FindElementOfType<ScheduleVerticalTimeSlotItemsControl>();
            var obj = VisualTreeHelper.GetChild(scheduleDayView, 0) as Grid;
            daysScrollViewer = obj?.FindName("Scrollviewer") as ScrollViewer;
            daysScrollViewer.ViewChanged += DaysScrollViewer_ViewChanged;
        }

        private void FindScheduleElements1()
        {
            if (isLoaded1)
            {
                scheduleDateView1 = GetScheduleDateView1(schedule1.VisibleDates[0]);
                isLoaded = false;
            }

            timeSlotControl1 = scheduleDateView1.FindElementOfType<ScheduleVerticalTimeSlotItemsControl>();

            var obj = VisualTreeHelper.GetChild(scheduleDateView1, 0) as Grid;
            daysScrollViewer1 = obj?.FindName("Scrollviewer") as ScrollViewer;
            daysScrollViewer1.ViewChanged += DaysScrollViewer1_ViewChanged;
           
        }

        private void DaysScrollViewer1_ViewChanged(object sender, ScrollViewerViewChangedEventArgs e)
        {
            daysScrollViewer.ScrollToVerticalOffset(daysScrollViewer1.VerticalOffset);
        }

        private void DaysScrollViewer_ViewChanged(object sender, ScrollViewerViewChangedEventArgs e)
        {
            daysScrollViewer1.ScrollToVerticalOffset(daysScrollViewer.VerticalOffset);
        }

        private ScheduleDaysView GetScheduleDateView(DateTime visibleDate)
        {
            var coll = schedule.FindElementOfType<LoopItemsPanel>().Children;
            if ((((coll[0] as Grid)?.Children[1] as ContentControl)?.Content as ScheduleDaysView)?.SelectedDates[0] ==
                visibleDate)
            {
                return ((((Grid)coll[0]).Children[1] as ContentControl)?.Content as ScheduleDaysView);
            }
            if ((((coll[1] as Grid)?.Children[1] as ContentControl)?.Content as ScheduleDaysView)?.SelectedDates[0] ==
                visibleDate)
            {
                return ((((Grid)coll[1]).Children[1] as ContentControl)?.Content as ScheduleDaysView);
            }

            return (((coll[2] as Grid)?.Children[1] as ContentControl)?.Content as ScheduleDaysView);
        }
        private ScheduleDaysView GetScheduleDateView1(DateTime visibleDate)
        {
            var coll = schedule1.FindElementOfType<LoopItemsPanel>().Children;
            if ((((coll[0] as Grid)?.Children[1] as ContentControl)?.Content as ScheduleDaysView)?.SelectedDates[0] ==
                visibleDate)
            {
                return ((((Grid)coll[0]).Children[1] as ContentControl)?.Content as ScheduleDaysView);
            }
            if ((((coll[1] as Grid)?.Children[1] as ContentControl)?.Content as ScheduleDaysView)?.SelectedDates[0] ==
                visibleDate)
            {
                return ((((Grid)coll[1]).Children[1] as ContentControl)?.Content as ScheduleDaysView);
            }

            return (((coll[2] as Grid)?.Children[1] as ContentControl)?.Content as ScheduleDaysView);
        }

     
      
    }
   
}
